﻿'Imports System.IO

Public Class Hinchdynamics
    '********** prepared pens **********
    Public BlackPen As Pen = New Pen(Color.Black, 1)
    Public BlackPen2 As Pen = New Pen(Color.Black, 2)
    Public BlackPen3 As Pen = New Pen(Color.Black, 3)
    Public BluePen As Pen = New Pen(Color.Blue, 1)
    Public BluePen2 As Pen = New Pen(Color.Blue, 2)
    Public BluePen3 As Pen = New Pen(Color.Blue, 3)
    Public RedPen As Pen = New Pen(Color.Red, 1)
    Public RedPen3 As Pen = New Pen(Color.Red, 3)
    Public RedPen2 As Pen = New Pen(Color.Red, 2)
    Public RedPen20 As Pen = New Pen(Color.Red, 20)
    Public ChocolatePen As Pen = New Pen(Color.Chocolate, 1)
    Public ChocolatePen2 As Pen = New Pen(Color.Chocolate, 2)
    Public ChocolatePen3 As Pen = New Pen(Color.Chocolate, 3)
    Public GreenPen As Pen = New Pen(Color.DarkGreen, 1)
    Public GreenPen2 As Pen = New Pen(Color.Green, 2)
    Public GreenPen3 As Pen = New Pen(Color.Green, 3)
    Public OlivePen As Pen = New Pen(Color.Olive, 1)
    Public LimePen As Pen = New Pen(Color.Lime, 1)
    Public LimePen3 As Pen = New Pen(Color.Lime, 3)
    Public GreenYellowPen As Pen = New Pen(Color.GreenYellow, 1)
    Public GreenYellowPen2 As Pen = New Pen(Color.GreenYellow, 2)
    Public LightCoralPen As Pen = New Pen(Color.LightCoral, 1)
    Public MagentaPen As Pen = New Pen(Color.Magenta, 1)
    Public VioletPen3 As Pen = New Pen(Color.Violet, 3)
    Public VioletPen2 As Pen = New Pen(Color.Violet, 2)
    Public VioletPen As Pen = New Pen(Color.Violet, 1)
    Public GrayPen As Pen = New Pen(Color.Gray, 1)
    Public GrayPen2 As Pen = New Pen(Color.Gray, 2)
    Public GrayPen3 As Pen = New Pen(Color.Gray, 3)
    Public DarkCyanPen As Pen = New Pen(Color.DarkCyan, 1)
    Public DarkMagentaPen As Pen = New Pen(Color.DarkMagenta, 1)
    Public OrangePen As Pen = New Pen(Color.Orange, 1)
    Public cyanPen As Pen = New Pen(Color.Cyan, 1)
    Public yellowPen As Pen = New Pen(Color.Yellow, 1)
    Public yellowPen2 As Pen = New Pen(Color.Yellow, 2)

    '**************** gradient pens ********************************
    Public gradient As New Graph2014.GradientPen(2)         '(pen width)
    Public gradient30 As New Graph2014.GradientPen(30)       '(pen width)
    Public gradient50 As New Graph2014.GradientPen(50)       '(pen width)

    '********** Graph Names **********
    Dim graphVmF As Graph2014      ' scale 1
    Dim graphpOF As Graph2014       'scale 
    Dim graphVmS As Graph2014
    Dim graphpOS As Graph2014

    Dim graphScheme1 As Graph2014
    Dim graphScheme2 As Graph2014

    '********** Graph Scales **********
    Dim MinX1 As Double = 8    '520                           'msec, Abscissa of the graph
    Dim MaxX1 As Double = 20  '532 
    Dim IntervalX1 As Double = 2

    Dim MinY1 As Double = -100                          'mV, ordinate, graph of membrane potential
    Dim MaxY1 As Double = 50
    Dim IntervalY1 As Double = 20

    Dim MinY2 As Double = 0                                  'open probability of RyR
    Dim MaxY2 As Double = 1
    Dim IntervalY2 As Double = 0.1

    Dim MinX2 As Double = 0                        'msec, Abscissa of the graph
    Dim MaxX2 As Double = 700 '500
    Dim IntervalX2 As Double = 100 '50

    Dim MinX3 As Double = 0                        'msec, Abscissa of the graph
    Dim MaxX3 As Double = 280
    Dim IntervalX3 As Double = 1

    Dim MinY3 As Double = 0                                  'open probability of RyR
    Dim MaxY3 As Double = 250
    Dim IntervalY3 As Double = 1



    '********** File to hold time variables **********
    Dim HV As New HuVECII
    Dim CsvFileName As String = "CsvHuVEC.csv"
    Dim names1() As String = New String() {"Vm", "TnChCa", "CaMCa", "bufferSRCa", "Lb_jnc", "Lb_iz", "Hb_jnc", "Hb_iz", "Nai", "Ki", _
    "Catot_jnc", "Catot_iz", "Catot_blk", "Ca_SRup", "Catot_SRrl", "O_TM", "I2_TM", "Is_TM", "O_LSM", _
    "I1_LSM", "I2_LSM", "Is_LSM", "Yco_iz", "Yoc_iz", "Yoo_iz", "Yco_blk", "Yoc_blk", "Yoo_blk", "Yooo", _
    "Yooc", "Ycoo", "Ycoc", "Ycco", "Yoco", "Yocc", "paraxrF", "paraxrS", "paraxs1_iz", "paraxs2_iz", "paraxs1_blk", _
    "paraxs2_blk", "a_IKto", "y1_IKto", "y2_IKto", "Pbspm", "E1NCX_iz", "I1NCX_iz", "I2NCX_iz", "E1NCX_blk", _
    "I1NCX_blk", "I2NCX_blk", "P1_6_NaK", "P7_NaK", "P8_13_NaK", "halfSL", "Fb", "Fp", "TSCa3", "TSCa3W", _
    "TSCa3S", "TSS", "TSW", "hw", "hp", "ATPt_cyt", "ADPt_cyt", "Pi_cyt", "PCr_cyt"}

    '********** Time step **********
    Public numSweep As Double                 'counter of sweeps
    Public dt As Double = 0.0002      '  msec, time step   time step if 0.00001 msec for the Keizer Levine model of RyR

    Public sweepTime As Double                 'msec   time for each sweep

    Dim DefineG As Boolean = True

    '******************************* Biological parameters used in Form **********************
    Dim weightkoc As Double            'net deactivation rate of RyRs
    Dim weightkco As Double            'net activation rate of RyRs

    Private Sub ButtonStart_Click(sender As Object, e As EventArgs) Handles ButtonStart.Click
        ButtonStart.Visible = False       'hide the starting command button

        ReadForm()                                   'Stimulus strength & Sweeptime max

        If DefineG Then                              'only when starting simulation
            DefineGraph()                                           'define graphs
            Clear()
        End If

        HV.DefaultValues()
        'CSVReadAndWrite.ReadCSV(CsvFileName, HV, names1)      'start from the last set of variables

        DrawAxes()                                              'clear graph and draw new graph grids

        dt = 0.0002
        sweepTime = 0                                         'reset sweepTime = 0
        Do                                       'Calculate individual sweep of the simulation
            My.Application.DoEvents()                                       'check events

            'If sweepTime >= 100 And sweepTime < 102 Then HV.Ca_SRup = 1.4 'CDbl(txtCaplus.Text) 'keep [Ca] in the SR_up 'Ca injection for a duration of 2 ms (= 102 - 100 ms)

            If sweepTime > 20 And dt < 0.01 Then dt = dt + 0.0002
            HV.ModelCell(sweepTime, dt)                'determination of dydt(N) by calculating the model using the variable name

            weightkoc = (HV.Yoco * HV.kYocoYocc + HV.Ycco * HV.kYccoYccc + HV.Ycoo * HV.kYcooYcoc + HV.Yooo * HV.kYoooYooc) / (HV.Yoco + HV.Ycco + HV.Ycoo + HV.Yooo)
            weightkco = (HV.Yocc * HV.kYoccYoco + HV.Yccc * HV.kYcccYcco + HV.Ycoc * HV.kYcocYcoo + HV.Yooc * HV.kYoocYooo) / (HV.Yocc + HV.Yccc + HV.Ycoc + HV.Yooc)     'weighted rate of activation of RyR

            PlotResults()
            PlotStates()

            sweepTime = sweepTime + dt                                  'msec, proceed with the experimental time within one sweep
        Loop While sweepTime < MaxX2           '************************** END of one Sweep ******************************************


        ButtonStart.Visible = True                                                      'display the start button


    End Sub


    Public Sub ReadForm()
        If rbBlinkS.Checked Then
            HV.BlinkS = True                   'The model include the blink space
            HV.ratioBS = CDbl(txtRatioBS.Text)               'ratio of gD_bs / gD_nd
        Else
            HV.BlinkS = False                   'No blink space is included in the model
        End If

        'txtInterval.Text = CStr(MaxX1)
        HV.Samplitude = CDbl(txtStimulus.Text)        'amplitude of the stimulus current in pA

        HV.IsoMetric = False                              'isotonic contraction
        HV.isometricL = CDbl(txthalfSL.Text)          'get the halfsarcomere length from the textbox
        HV.Fext = CDbl(txtFext.Text)                        'get Fext from the textbox

        HV.sclI1I2 = 1                    'scaling factor for kI1I2 of the late scattered mode Na channel
        HV.scaleIKr = 1                'scaling factor for IKr amplitude 

        HV.clampMode = "Iclamp"                'always Current Clamp Mode in the present protocol

        HV.fNaK = 1                'scaling the Na/K pump current during digitalis experiments

    End Sub

    Dim Tplot As Double = 0
    Dim Tskip As Double = 0   'dt * 6 '2.1
    Dim Tint As Double = 0.2  'dt * 5     'ms interval for drawing interrupted line

    Private Sub PlotResults()

        'Dim pORyR As Double = HV.Yooo + HV.Ycoo + HV.Ycco + HV.Yoco
        'graphpO3.PlotPoint(sweepTime, pORyR, RedPen2)
        If sweepTime > MinX1 And sweepTime < MaxX1 Then
            graphVmF.PlotPoint(sweepTime, HV.Vm, BlackPen2)

            graphpOF.PlotPoint(sweepTime, HV.Yooc, ChocolatePen2)
            graphpOF.PlotPoint(sweepTime, HV.Yooo, RedPen2)
            graphpOF.PlotPoint(sweepTime, HV.Yoco, BluePen2)
            graphpOF.PlotPoint(sweepTime, HV.Yocc, GrayPen2)
            graphpOF.PlotPoint(sweepTime, HV.Yccc, GreenYellowPen2)
            graphpOF.PlotPoint(sweepTime, HV.Ycoc, GreenPen2)
            graphpOF.PlotPoint(sweepTime, HV.Ycoo, VioletPen2)
            graphpOF.PlotPoint(sweepTime, HV.Ycco, yellowPen2)
        End If

        graphVmS.PlotPoint(sweepTime, HV.Vm, BlackPen2)

        graphpOS.PlotPoint(sweepTime, HV.Yooc, ChocolatePen2)
        graphpOS.PlotPoint(sweepTime, HV.Yooo, RedPen2)
        graphpOS.PlotPoint(sweepTime, HV.Yoco, BluePen2)
        graphpOS.PlotPoint(sweepTime, HV.Yocc, GrayPen2)
        graphpOS.PlotPoint(sweepTime, HV.Yccc, GreenYellowPen2)
        graphpOS.PlotPoint(sweepTime, HV.Ycoc, GreenPen2)
        graphpOS.PlotPoint(sweepTime, HV.Ycoo, VioletPen2)
        graphpOS.PlotPoint(sweepTime, HV.Ycco, yellowPen2)

        'Dim yvalue As Double = weightkco / (weightkco + weightkoc)
        'graphpO3.PlotPoint(sweepTime, yvalue, BluePen2)

    End Sub


    Dim OX As Double = -30          'origin X
    Dim OY As Double = 10           'origin Y
    Dim IX As Double = 200           'interval X
    Dim IY As Double = 150           'interval Y
    Dim dX As Double = 50            'shadow X
    Dim dY As Double = 50            'shadow Y
    Dim bW As Double = 80           'box width
    'Dim bH As Double = 40            'box height

    Private Sub PlotStates()

        graphScheme2.PlotLine(OX, OY, OX + bW, OY, gradient50.PenRedBlue(HV.Yooo, 0, 1))
        graphScheme2.PlotLine(OX + IX, OY, OX + IX + bW, OY, gradient50.PenRedBlue(HV.Yooc, 0, 1))
        graphScheme2.PlotLine(OX + dX, OY + dY, OX + dX + bW, OY + dY, gradient50.PenRedBlue(HV.Yoco, 0, 1))
        graphScheme2.PlotLine(OX + IX + dX, OY + dY, OX + IX + dX + bW, OY + dY, gradient50.PenRedBlue(HV.Yocc, 0, 1))

        graphScheme2.PlotLine(OX, OY + IY, OX + bW, OY + IY, gradient50.PenRedBlue(HV.Ycoo, 0, 1))
        graphScheme2.PlotLine(OX + IX, OY + IY, OX + IX + bW, OY + IY, gradient50.PenRedBlue(HV.Ycoc, 0, 1))
        graphScheme2.PlotLine(OX + IX + dX, OY + dY + IY, OX + IX + dX + bW, OY + dY + IY, gradient50.PenRedBlue(HV.Yccc, 0, 1))
        graphScheme2.PlotLine(OX + dX, OY + dY + IY, OX + dX + bW, OY + dY + IY, gradient50.PenRedBlue(HV.Ycco, 0, 1))

    End Sub

    Private Sub DefineGraph()
        graphVmF = New Graph2014(pbVmF, MinX1, MaxX1, MinY1, MaxY1)
        graphpOF = New Graph2014(pbpOF, MinX1, MaxX1, MinY2, MaxY2)

        graphVmS = New Graph2014(pbVmS, MinX2, MaxX2, MinY1, MaxY1)
        graphpOS = New Graph2014(pbpOS, MinX2, MaxX2, MinY2, MaxY2)

        'graphScheme1 = New Graph2014(pbScheme1, MinX3, MaxX3, MinY3, MaxY3)
        graphScheme2 = New Graph2014(pbscheme2, MinX3, MaxX3, MinY3, MaxY3)
    End Sub

    Private Sub Clear()
        graphVmF.Clear()
        graphpOF.Clear()
        graphVmS.Clear()
        graphpOS.Clear()

        graphScheme2.Clear()
    End Sub


    Private Sub DrawAxes()
        graphVmF.DrawAxis(IntervalX1, IntervalY1, "", 8)
        graphpOF.DrawAxis(IntervalX1, IntervalY2, "", 8)

        graphVmF.PlotLine(HV.ItestOff, MinY1, HV.ItestOff, MaxY1, BlackPen2)
        graphpOF.PlotLine(HV.ItestOff, MinY2, HV.ItestOff, MaxY2, BlackPen2)
        graphVmF.PlotLine(HV.ItestOn, MinY1, HV.ItestOn, MaxY1, BlackPen2)
        graphpOF.PlotLine(HV.ItestOn, MinY2, HV.ItestOn, MaxY2, BlackPen2)

        graphVmS.DrawAxis(IntervalX2, IntervalY1, "", 8)
        graphpOS.DrawAxis(IntervalX2, IntervalY2, "", 8)

        graphVmS.PlotLine(HV.ItestOff, MinY1, HV.ItestOff, MaxY1, BlackPen2)
        graphpOS.PlotLine(HV.ItestOff, MinY2, HV.ItestOff, MaxY2, BlackPen2)
        graphVmS.PlotLine(HV.ItestOn, MinY1, HV.ItestOn, MaxY1, BlackPen2)
        graphpOS.PlotLine(HV.ItestOn, MinY2, HV.ItestOn, MaxY2, BlackPen2)

        'graphScheme1.PlotLine(OX, OY, OX + IX, OY, BlackPen)
        'graphScheme1.PlotLine(OX + IX, OY, OX + IX + dX, OY + dY, BlackPen)
        'graphScheme1.PlotLine(OX + IX + dX, OY + dY, OX + dX, OY + dY, BlackPen)
        'graphScheme1.PlotLine(OX + dX, OY + dY, OX, OY, BlackPen)

        'graphScheme1.PlotLine(OX, OY + IY, OX + IX, OY + IY, BlackPen)
        'graphScheme1.PlotLine(OX + IX, OY + IY, OX + IX + dX, OY + dY + IY, BlackPen)
        'graphScheme1.PlotLine(OX + IX + dX, OY + dY + IY, OX + dX, OY + dY + IY, BlackPen)
        'graphScheme1.PlotLine(OX + dX, OY + dY + IY, OX, OY + IY, BlackPen)

        'graphScheme1.PlotLine(OX, OY, OX, OY + IY, BlackPen)
        'graphScheme1.PlotLine(OX + IX, OY, OX + IX, OY + IY, BlackPen)
        'graphScheme1.PlotLine(OX + IX + dX, OY + dY, OX + dX + IX, OY + dY + IY, BlackPen)
        'graphScheme1.PlotLine(OX + dX, OY + dY, OX + dX, OY + dY + IY, BlackPen)

        graphScheme2.PlotLine(OX, OY, OX + IX, OY, BlackPen2)
        graphScheme2.PlotLine(OX + IX, OY, OX + IX + dX, OY + dY, BlackPen2)
        graphScheme2.PlotLine(OX + IX + dX, OY + dY, OX + dX, OY + dY, BlackPen2)
        graphScheme2.PlotLine(OX + dX, OY + dY, OX, OY, BlackPen2)

        graphScheme2.PlotLine(OX, OY + IY, OX + IX, OY + IY, BlackPen2)
        graphScheme2.PlotLine(OX + IX, OY + IY, OX + IX + dX, OY + dY + IY, BlackPen2)
        graphScheme2.PlotLine(OX + IX + dX, OY + dY + IY, OX + dX, OY + dY + IY, BlackPen2)
        graphScheme2.PlotLine(OX + dX, OY + dY + IY, OX, OY + IY, BlackPen2)

        graphScheme2.PlotLine(OX, OY, OX, OY + IY, BlackPen2)
        graphScheme2.PlotLine(OX + IX, OY, OX + IX, OY + IY, BlackPen2)
        graphScheme2.PlotLine(OX + IX + dX, OY + dY, OX + dX + IX, OY + dY + IY, BlackPen2)
        graphScheme2.PlotLine(OX + dX, OY + dY, OX + dX, OY + dY + IY, BlackPen2)

    End Sub

    'Dim OX As Double = -30          'origin X
    'Dim OY As Double = 10           'origin Y
    'Dim IX As Double = 200           'interval X
    'Dim IY As Double = 150           'interval Y
    'Dim dX As Double = 50            'shadow X
    'Dim dY As Double = 50            'shadow Y
    'Dim bW As Double = 80           'box width
    ''Dim bH As Double = 40            'box height

    'Private Sub PlotStates()
    '    'graphScheme.PlotRectangle(RedPen, OX, OY, bW, bH)
    '    'graphScheme.PlotLine(OX, OY, OX + bW, OY, RedPen20)

    '    graphScheme.PlotLine(OX, OY, OX + bW, OY, gradient30.PenRedBlue(HV.Yooo, 0, 1))
    '    graphScheme.PlotLine(OX + IX, OY, OX + IX + bW, OY, gradient30.PenRedBlue(HV.Yooc, 0, 1))
    '    graphScheme.PlotLine(OX + dX, OY + dY, OX + dX + bW, OY + dY, gradient30.PenRedBlue(HV.Yoco, 0, 1))
    '    graphScheme.PlotLine(OX + IX + dX, OY + dY, OX + IX + dX + bW, OY + dY, gradient30.PenRedBlue(HV.Yocc, 0, 1))

    '    graphScheme.PlotLine(OX, OY + IY, OX + bW, OY + IY, gradient30.PenRedBlue(HV.Ycoo, 0, 1))
    '    graphScheme.PlotLine(OX + IX, OY + IY, OX + IX + bW, OY + IY, gradient30.PenRedBlue(HV.Ycoc, 0, 1))
    '    graphScheme.PlotLine(OX + IX + dX, OY + dY + IY, OX + IX + dX + bW, OY + dY + IY, gradient30.PenRedBlue(HV.Yccc, 0, 1))
    '    graphScheme.PlotLine(OX + dX, OY + dY + IY, OX + dX + bW, OY + dY + IY, gradient30.PenRedBlue(HV.Ycco, 0, 1))

    'End Sub

    Private Sub cbReset_Click(sender As Object, e As EventArgs) Handles cbReset.Click
        sweepTime = MaxX2 + 1
    End Sub

    Private Sub cbErase_Click(sender As Object, e As EventArgs) Handles cbErase.Click
        Clear()
    End Sub

    Private Sub ButtonEnd_Click(sender As Object, e As EventArgs) Handles ButtonEnd.Click
        End
    End Sub
End Class